indexing
   description: "Factory to create the components of a MAZE"
   date: "2004 March 28"
   version: "1.0"
   author: "Gunnar Gotshalks"

class MAZE_FACTORY

feature {ANY} -- Maze parts

make_maze : MAZE is 
  do 
    create Result.make 
  end

make_wall(id : STRING) : WALL is
  -- Create a wall to insert into a maze.
  require
    id_not_void : id /= void
  do
    create Result.make(id)
    ensure created: Result /= Void
  end

make_room (id : STRING) : ROOM is
  -- Create a room to insert into a maze.
  require
    id_not_void : id /= void
  do
    create Result.make(id)
    ensure created: Result /= Void
  end
  
make_door (id : STRING ; r1, r2 : ROOM) : DOOR is
  -- Create a door to insert into a maze.
  require
    rooms_exist: r1 /= void and r2 /= void
    rooms_different : r1 /= r2
    id_not_void : id /= void
  do
    create Result.make(id, r1, r2)
    ensure created: Result /= Void
  end
  
end -- MAZE_FACTORY

