indexing
   description: "Describes ROOM objects"
   date: "2004 March 28"
   version: "1.0"
   author: "Gunnar Gotshalks"

class ROOM
  inherit MAZE_COMPONENT
  
creation make

feature -- Intialization

make (room_id: STRING) is
  -- Creation and initialization
  require room_has_id: room_id /= void
  do
    id := room_id
  ensure
    id_set: id = room_id
  end

feature {ANY} -- Attributes

north_side : ROOM_COMPONENT
east_side  : ROOM_COMPONENT
south_side : ROOM_COMPONENT
west_side  : ROOM_COMPONENT

occupied : BOOLEAN  -- True if room is occupied

feature {ANY} -- Commands

enter is do print("You enter "); describe; print(".%N") end

describe is
  do
    print(id)
    if occupied then print(" occupied")
    else print(" empty")    	
    end
    print(" with%N    ")
    north_side.describe   print(" (N),")
    east_side.describe    print(" (E),")
    south_side.describe   print(" (S),")
    west_side.describe    print(" (W).%N")
  end

set_side (side : INTEGER ; component : ROOM_COMPONENT) is
  -- Set the component into the side of the room
  require side_exists: 1 <= side and side <= 4
  do
    if side = 1 then north_side := component
    elseif side = 2 then east_side := component
    elseif side = 3 then south_side := component
    else west_side := component
    end
  end

end

