indexing
   description: "A maze game to play"
   date: "2004 March 28"
   version: "1.0"
   author: "Gunnar Gotshalks"

class MAZE_GAME

creation create_maze feature

feature {NONE} -- Initialization

create_maze(factory : MAZE_FACTORY ) is
  do
    -- Maze consists of two rooms with a connecting door
    
    maze := factory.make_maze
    r1 := factory.make_room ("Room 1")
    r2 := factory.make_room("Room 2")
    door := factory.make_door ("Door 1-2", r1, r2 )
    maze.add_room (r1 )  ;  maze.add_room ( r2 )

    -- Build the two rooms

    a_wall := factory.make_wall("Wall 1")
    r1.set_side ( North , a_wall)
    r1.set_side ( East  , door )
    a_wall := factory.make_wall("Wall 2")
    r1.set_side ( South , a_wall)
    a_wall := factory.make_wall("Wall 3")
    r1.set_side ( West  , a_wall)

    a_wall := factory.make_wall("Wall 4")
    r2.set_side ( North , a_wall)
    a_wall := factory.make_wall("Wall 5")
    r2.set_side ( East  , a_wall)
    a_wall := factory.make_wall("Wall 6")
    r2.set_side ( South , a_wall)
    r2.set_side ( West  , door)
  end

feature {NONE} -- Implementation

North, East,South, West : INTEGER is unique
r1, r2 : ROOM
door : DOOR
a_wall : WALL

feature -- Attributes

maze : MAZE

end
