indexing
   description: "Factory to create the components of an enchanted MAZE"
   date: "2004 March 28"
   version: "1.0"
   author: "Gunnar Gotshalks"

class ENCHANTED_MAZE_FACTORY
inherit MAZE_FACTORY
	    redefine make_room, make_door end

feature {ANY} -- Maze parts
make_room (id : STRING) : ENCHANTED_ROOM is 
  -- Creates an enchanted room
  do 
    cast_a_spell(id)
    create Result.make(id,last_spell_cast) 
  end

make_door (id : STRING; r1, r2 : ROOM) : LOCKED_DOOR is
  do
    create Result.make(id,r1,r2)
  end
  
feature {NONE} -- Implementation

last_spell_cast : SPELL

cast_a_spell(id : STRING) is
  do
    create last_spell_cast
    last_spell_cast.set_name( "Spell-"
      + id.substring(id.count, id.count))
  end

end

